Search:

# CWIS Developers Documentation

- Main Page
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Resource Class Reference

Represents a "resource" in CWIS. More...

List of all members.

## Public Member Functions
| Resource ($ResourceId=NULL)
| Object constructor.
| Delete ()
| Remove resource (and accompanying associations) from database and delete any associated files.
| Status ()
| Retrieve result of last operation if available.
| Id ()
| Retrieve numerical resource ID.
| IsTempResource ($NewSetting=NULL)
| Get/set whether resource is a temporary record.
| Get ($FieldNameOrObject, $ReturnObject=FALSE, $IncludeVariants=FALSE)
| Retrieve value using field name or field object.
| GetByField ($FieldNameOrObject, $ReturnObject=FALSE, $IncludeVariants=FALSE)
| Old method for retrieving values, deprecated in favor of Get().
| GetByFieldId ($FieldId, $ReturnObject=FALSE, $IncludeVariants=FALSE)
| Retrieve value using field ID.
| GetAsArray ($IncludeDisabledFields=FALSE, $ReturnObjects=TRUE)
| Retrieve all resource values as an array.
| GetMapped ($MappedName, $ReturnObject=FALSE, $IncludeVariants=FALSE)
| Retrieve value using standard (mapped) field name.
| GetQualifier ($FieldName, $ReturnObject=TRUE)
| Retrieve qualifier by field name.
| GetQualifierByFieldId ($FieldId, $ReturnObject=TRUE)
| Retrieve qualifier by field ID.
| GetQualifierByField ($Field, $ReturnObject=TRUE)
| Retrieve qualifier by Field object.
| Set ($FieldNameOrObject, $NewValue)
| SetByField ($Field, $NewValue)
| SetByFieldId ($FieldId, $NewValue)
| SetQualifier ($FieldName, $NewValue)
| SetQualifierByFieldId ($FieldId, $NewValue)
| SetQualifierByField ($Field, $NewValue)
| Clear ($FieldName, $ValueToClear=NULL)
| ClearByFieldId ($FieldId, $ValueToClear=NULL)
| ClearByField ($Field, $ValueToClear=NULL)
| Classifications ()
| CumulativeRating ()
| ScaledCumulativeRating ()
| NumberOfRatings ()
| Rating ($NewRating=NULL, $UserId=NULL)
| Comments ()
| NumberOfComments ()
| UserCanEdit ($User)
| UserCanViewField ($User, $FieldOrFieldName)
| UserCanAuthorField ($User, $FieldOrFieldName)
| UserCanEditField ($User, $FieldOrFieldName)

## Detailed Description

Represents a "resource" in CWIS.

Definition at line 13 of file Resource.php.

## Member Function Documentation

Resource::Classifications | ( |  | ) |

Definition at line 1516 of file Resource.php.

References Id().

Referenced by Delete().

Here is the caller graph for this function:

Resource::Clear | ( | $ | FieldName,
|  | $ | ValueToClear = `NULL` |
| ) |  |  |

Definition at line 1247 of file Resource.php.

References ClearByField().

Resource::ClearByField | ( | $ | Field,
|  | $ | ValueToClear = `NULL` |
| ) |  |  |

Definition at line 1261 of file Resource.php.

References Get(), Id(), IsTempResource(), MetadataSchema::MDFTYPE_CONTROLLEDNAME, MetadataSchema::MDFTYPE_DATE, MetadataSchema::MDFTYPE_FILE, MetadataSchema::MDFTYPE_FLAG, MetadataSchema::MDFTYPE_IMAGE, MetadataSchema::MDFTYPE_NUMBER, MetadataSchema::MDFTYPE_OPTION, MetadataSchema::MDFTYPE_PARAGRAPH, MetadataSchema::MDFTYPE_POINT, MetadataSchema::MDFTYPE_TEXT, MetadataSchema::MDFTYPE_TIMESTAMP, MetadataSchema::MDFTYPE_TREE, MetadataSchema::MDFTYPE_URL, and MetadataSchema::MDFTYPE_USER.

Referenced by Clear(), and ClearByFieldId().

Here is the caller graph for this function:

Resource::ClearByFieldId | ( | $ | FieldId,
|  | $ | ValueToClear = `NULL` |
| ) |  |  |

Definition at line 1254 of file Resource.php.

References ClearByField().

Resource::Comments | ( |  | ) |

Definition at line 1673 of file Resource.php.

References Id().

Resource::CumulativeRating | ( |  | ) |

Definition at line 1545 of file Resource.php.

Referenced by GetAsArray(), NumberOfRatings(), Resource(), and ScaledCumulativeRating().

Here is the caller graph for this function:

Resource::Delete | ( |  | ) |

Remove resource (and accompanying associations) from database and delete any associated files.

Definition at line 133 of file Resource.php.

References Classifications(), Id(), and MetadataSchema::MDFTYPE_IMAGE.

Resource::Get | ( | $ | FieldNameOrObject,
|  | $ | ReturnObject = `FALSE`,
|  | $ | IncludeVariants = `FALSE` |
| ) |  |  |

Retrieve value using field name or field object.

Parameters:

  | FieldNameOrObject | Full name of field or a Field object.
  | ReturnObject | For field types that can return multiple values, if TRUE, returns array of objects, else returns array of values. Defaults to FALSE.
  | IncludeVariants | If TRUE, includes variants in return value. Only applicable for ControlledName fields.

Returns:
  Requested object(s) or value(s). Returns empty array (for field types that allow multiple values) or NULL (for field types that do not allow multiple values) if no values found. Returns NULL if field does not exist or was otherwise invalid.

See also:
  GetByFieldId

Definition at line 303 of file Resource.php.

References Id(), MetadataSchema::MDFSTAT_OK, MetadataSchema::MDFTYPE_CONTROLLEDNAME, MetadataSchema::MDFTYPE_DATE, MetadataSchema::MDFTYPE_FILE, MetadataSchema::MDFTYPE_FLAG, MetadataSchema::MDFTYPE_IMAGE, MetadataSchema::MDFTYPE_NUMBER, MetadataSchema::MDFTYPE_OPTION, MetadataSchema::MDFTYPE_PARAGRAPH, MetadataSchema::MDFTYPE_POINT, MetadataSchema::MDFTYPE_TEXT, MetadataSchema::MDFTYPE_TIMESTAMP, MetadataSchema::MDFTYPE_TREE, MetadataSchema::MDFTYPE_URL, MetadataSchema::MDFTYPE_USER, and Status().

Referenced by ClearByField(), GetAsArray(), GetByField(), GetByFieldId(), GetQualifierByField(), Set(), UserCanAuthorField(), UserCanEditField(), and UserCanViewField().

Here is the caller graph for this function:

Resource::GetAsArray | ( | $ | IncludeDisabledFields = `FALSE`,
|  | $ | ReturnObjects = `TRUE` |
| ) |  |  |

Retrieve all resource values as an array.

Parameters:

  | IncludeDisabledFields | Include values for disabled fields. (OPTIONAL, defaults to FALSE)
  | ReturnObjects | If TRUE, an object is returned for field types where appropriate, in the same fashion as Resource::Get() (OPTIONAL, defaults to TRUE)

Returns:
  Array of values with field names for array indices. Qualifiers (where available) are returned with an index of the field name with " Qualifier" appended.

See also:
  Get

Definition at line 558 of file Resource.php.

References CumulativeRating(), Get(), GetQualifierByField(), and Id().

Resource::GetByField | ( | $ | FieldNameOrObject,
|  | $ | ReturnObject = `FALSE`,
|  | $ | IncludeVariants = `FALSE` |
| ) |  |  |

Old method for retrieving values, deprecated in favor of Get().

See also:
  Get

Definition at line 523 of file Resource.php.

References Get().

Resource::GetByFieldId | ( | $ | FieldId,
|  | $ | ReturnObject = `FALSE`,
|  | $ | IncludeVariants = `FALSE` |
| ) |  |  |

Retrieve value using field ID.

Parameters:

  | FieldId | ID of field.
  | ReturnObject | For field types that can return multiple values, if TRUE, returns array of objects, else returns array of values. Defaults to FALSE.
  | IncludeVariants | If TRUE, includes variants in return value. Only applicable for ControlledName fields.

Returns:
  Requested object(s) or value(s). Returns empty array (for field types that allow multiple values) or NULL (for field types that do not allow multiple values) if no values found.

See also:
  Get

Definition at line 540 of file Resource.php.

References Get().

Referenced by GetMapped().

Here is the caller graph for this function:

Resource::GetMapped | ( | $ | MappedName,
|  | $ | ReturnObject = `FALSE`,
|  | $ | IncludeVariants = `FALSE` |
| ) |  |  |

Retrieve value using standard (mapped) field name.

Parameters:

  | MappedName | Standard field name.
  | ReturnObject | For field types that can return multiple values, if TRUE, returns array of objects, else returns array of values. Defaults to FALSE.
  | IncludeVariants | If TRUE, includes variants in return value. Only applicable for ControlledName fields. Defaults to FALSE.

Returns:
  Requested object(s) or value(s), or NULL if no mapping found. Returns empty array (for field types that allow multiple values) or NULL (for field types that do not allow multiple values) if no values found.

See also:
  Get

Definition at line 604 of file Resource.php.

References GetByFieldId().

Resource::GetQualifier | ( | $ | FieldName,
|  | $ | ReturnObject = `TRUE` |
| ) |  |  |

Retrieve qualifier by field name.

Parameters:

  | FieldName | Full name of field.
  | ReturnObject | If TRUE, return Qualifier objects, else return qualifier IDs. Defaults to TRUE.

Returns:
  Array of qualifiers if field supports qualifiers, or NULL if field does not support qualifiers.

Definition at line 620 of file Resource.php.

References GetQualifierByField().

Resource::GetQualifierByField | ( | $ | Field,
|  | $ | ReturnObject = `TRUE` |
| ) |  |  |

Retrieve qualifier by Field object.

Parameters:

  | Field | Field object.
  | ReturnObject | If TRUE, return Qualifier objects, else return qualifier IDs. Defaults to TRUE.

Returns:
  Array of qualifiers if field supports qualifiers, or NULL if field does not support qualifiers or field is invalid.

Definition at line 648 of file Resource.php.

References $Items, Get(), MetadataSchema::MDFSTAT_OK, MetadataSchema::MDFTYPE_CONTROLLEDNAME, MetadataSchema::MDFTYPE_OPTION, MetadataSchema::MDFTYPE_TREE, and Status().

Referenced by GetAsArray(), GetQualifier(), and GetQualifierByFieldId().

Here is the caller graph for this function:

Resource::GetQualifierByFieldId | ( | $ | FieldId,
|  | $ | ReturnObject = `TRUE` |
| ) |  |  |

Retrieve qualifier by field ID.

Parameters:

  | FieldId | ID of field.
  | ReturnObject | If TRUE, return Qualifier objects, else return qualifier IDs. Defaults to TRUE.

Returns:
  Array of qualifiers if field supports qualifiers, or NULL if field does not support qualifiers.

Definition at line 634 of file Resource.php.

References GetQualifierByField().

Resource::Id | ( |  | ) |

Retrieve numerical resource ID.

Returns:
  Resource ID.

Definition at line 222 of file Resource.php.

Referenced by Classifications(), ClearByField(), Comments(), Delete(), Get(), GetAsArray(), IsTempResource(), NumberOfComments(), NumberOfRatings(), Rating(), Resource(), Set(), SetQualifierByField(), and UserCanEdit().

Here is the caller graph for this function:

Resource::IsTempResource | ( | $ | NewSetting = `NULL` | ) |

Get/set whether resource is a temporary record.

Parameters:

  | NewSetting | TRUE/FALSE setting for whether resource is temporary. (OPTIONAL)

Returns:
  TRUE if resource is temporary record, or FALSE otherwise.

Definition at line 229 of file Resource.php.

References Id().

Referenced by ClearByField(), and Set().

Here is the caller graph for this function:

Resource::NumberOfComments | ( |  | ) |

Definition at line 1693 of file Resource.php.

References Id().

Resource::NumberOfRatings | ( |  | ) |

Definition at line 1561 of file Resource.php.

References CumulativeRating(), and Id().

Resource::Rating | ( | $ | NewRating = `NULL`,
|  | $ | UserId = `NULL` |
| ) |  |  |

Definition at line 1586 of file Resource.php.

References Id().

Resource::Resource | ( | $ | ResourceId = `NULL` | ) |

Object constructor.

Parameters:

  | ResourceId | ID of resource to load. New resource is created if no ID is supplied.

Definition at line 22 of file Resource.php.

References CumulativeRating(), Id(), MetadataSchema::MDFTYPE_FLAG, MetadataSchema::MDFTYPE_NUMBER, MetadataSchema::MDFTYPE_OPTION, MetadataSchema::MDFTYPE_POINT, MetadataSchema::MDFTYPE_TEXT, MetadataSchema::MDFTYPE_TIMESTAMP, SetByField(), and MetadataField::UPDATEMETHOD_ONRECORDCREATE.

Resource::ScaledCumulativeRating | ( |  | ) |

Definition at line 1548 of file Resource.php.

References CumulativeRating().

Resource::Set | ( | $ | FieldNameOrObject,
|  | $ | NewValue |
| ) |  |  |

Definition at line 778 of file Resource.php.

References Classification::CLASSSTAT_OK, Get(), Id(), IsTempResource(), MetadataSchema::MDFTYPE_CONTROLLEDNAME, MetadataSchema::MDFTYPE_DATE, MetadataSchema::MDFTYPE_FILE, MetadataSchema::MDFTYPE_FLAG, MetadataSchema::MDFTYPE_IMAGE, MetadataSchema::MDFTYPE_NUMBER, MetadataSchema::MDFTYPE_OPTION, MetadataSchema::MDFTYPE_PARAGRAPH, MetadataSchema::MDFTYPE_POINT, MetadataSchema::MDFTYPE_TEXT, MetadataSchema::MDFTYPE_TIMESTAMP, MetadataSchema::MDFTYPE_TREE, MetadataSchema::MDFTYPE_URL, MetadataSchema::MDFTYPE_USER, and Status().

Referenced by SetByField(), and SetByFieldId().

Here is the caller graph for this function:

Resource::SetByField | ( | $ | Field,
|  | $ | NewValue |
| ) |  |  |

Definition at line 1194 of file Resource.php.

References Set().

Referenced by Resource().

Here is the caller graph for this function:

Resource::SetByFieldId | ( | $ | FieldId,
|  | $ | NewValue |
| ) |  |  |

Definition at line 1197 of file Resource.php.

References Set().

Resource::SetQualifier | ( | $ | FieldName,
|  | $ | NewValue |
| ) |  |  |

Definition at line 1204 of file Resource.php.

References SetQualifierByField().

Resource::SetQualifierByField | ( | $ | Field,
|  | $ | NewValue |
| ) |  |  |

Definition at line 1218 of file Resource.php.

References Id().

Referenced by SetQualifier(), and SetQualifierByFieldId().

Here is the caller graph for this function:

Resource::SetQualifierByFieldId | ( | $ | FieldId,
|  | $ | NewValue |
| ) |  |  |

Definition at line 1211 of file Resource.php.

References SetQualifierByField().

Resource::Status | ( |  | ) |

Retrieve result of last operation if available.

Returns:
  Result of last operation (if available).

Definition at line 216 of file Resource.php.

Referenced by Get(), GetQualifierByField(), and Set().

Here is the caller graph for this function:

Resource::UserCanAuthorField | ( | $ | User,
|  | $ | FieldOrFieldName |
| ) |  |  |

Definition at line 1815 of file Resource.php.

References Get(), MetadataField::USERISVALUE_OR, and MetadataField::USERISVALUE_UNSET.

Referenced by UserCanEditField().

Here is the caller graph for this function:

Resource::UserCanEdit | ( | $ | User | ) |

Definition at line 1715 of file Resource.php.

References Id().

Resource::UserCanEditField | ( | $ | User,
|  | $ | FieldOrFieldName |
| ) |  |  |

Definition at line 1906 of file Resource.php.

References Get(), UserCanAuthorField(), MetadataField::USERISVALUE_OR, and MetadataField::USERISVALUE_UNSET.

Referenced by UserCanViewField().

Here is the caller graph for this function:

Resource::UserCanViewField | ( | $ | User,
|  | $ | FieldOrFieldName |
| ) |  |  |

Definition at line 1725 of file Resource.php.

References Get(), UserCanEditField(), MetadataField::USERISVALUE_OR, and MetadataField::USERISVALUE_UNSET.

The documentation for this class was generated from the following file:

- Resource.php